//////////////////////////////
//    Dynamic-AI-Creator    //
//    Version 2.0 - 2007    //
//--------------------------//
//    DAC_Config_Marker     //
//--------------------------//
//    Script by Silola      //
//    silola@mapfact.net    //
//////////////////////////////

private [
			"_MarkerConfig","_MarkerSet","_s","_setShowZones","_setShowWPs","_setShowUnit","_setGroupType",
			"_setMarkerText","_setMarkerDel","_setMarkerRefresh","_setSizeWpLine","_setSizeLeaderLine",
			"_setSizeZoneLine","_setSizeCampLine","_setSizeZoneBorder","_setArtiMarker","_setCampMarker",
			"_setMarkerClass","_setSideColor","_MarkerValues"
		];

_MarkerSet = 	[
					"_setShowZones","_setShowWPs","_setShowUnit","_setGroupType","_setMarkerText",
					"_setMarkerDel","_setMarkerRefresh","_setSizeWpLine","_setSizeLeaderLine",
					"_setSizeZoneLine","_setSizeCampLine","_setSizeZoneBorder","_setArtiMarker",
					"_setCampMarker","_setSideColor","_setMarkerClass"
				];

					_MarkerConfig = _this select 0;_MarkerValues = [0];_s = 0;

if(_MarkerConfig == 0) exitwith {};

switch (_MarkerConfig) do
{
//-----------------------------------------------------------------------------------------------
	case 1:	{		
				_setShowZones 		= 2;
				_setShowWPs 		= 0;
				_setShowUnit 		= [1,1,1,1];
				_setGroupType 		= 1;
				_setMarkerText		= ["if(format[""%1"",_group] == ""<NULL-group>"") then {format[""<--- %1"",typeof _unit]} else {format[""<--- %1 (%2)"",_group,count units _group]}"];
				_setMarkerDel 		= 0;
				_setMarkerRefresh 	= [1,1];
				_setSizeWpLine 		= [0,0];
				_setSizeLeaderLine 	= 0.5;
				_setSizeZoneLine 	= 3;
				_setSizeCampLine 	= 4;
				_setSizeZoneBorder 	= 6;
				_setArtiMarker 		= 1;
				_setCampMarker 		= 2;
				_setSideColor 		= [
										"ColorRed",
										"ColorBlue",
										"ColorYellow",
										"ColorGreen",
										"ColorWhite",
										"ColorBlack","ColorGreen"
									  ];
				_setMarkerClass		= [
										[
											["STATICWEAPON","Dot",[0.4,0.6],1]
										],
										[
											["MAN","Dot",[0.5,0.5],0]
										],
										[
											["CAR","Dot",[0.6,0.7],0],
											["TRUCK","Dot",[0.6,0.8],0]
										],
										[
											["TANK","Dot",[0.7,0.9],0],
											["APC","Dot",[0.6,0.9],0]
										],
										[
											["MOTORCYCLE","Dot",[0.2,0.6],0]
										],
										[
											["AIR","Dot",[0.5,1],0]
										],
										[
											["SHIP","Dot",[0.8,1.2],1]
										],
										[
											["OTHER","Dot",[0.6,0.6],1]
										]
									  ];
			};
//-----------------------------------------------------------------------------------------------
	case 2:	{		
				_setShowZones 		= 2;
				_setShowWPs 		= 1;
				_setShowUnit 		= [1,1,1,1];
				_setGroupType 		= 1;
				_setMarkerText		= [];
				_setMarkerDel 		= 0;
				_setMarkerRefresh 	= [0.3,0.3];
				_setSizeWpLine 		= [0,0];
				_setSizeLeaderLine 	= 0.5;
				_setSizeZoneLine 	= 3;
				_setSizeCampLine 	= 2;
				_setSizeZoneBorder 	= 6;
				_setArtiMarker 		= 1;
				_setCampMarker 		= 2;
				_setSideColor 		= [
										"ColorRed",
										"ColorBlue",
										"ColorYellow",
										"ColorGreen",
										"ColorWhite",
										"ColorBlack","ColorGreen"
									  ];
				_setMarkerClass		= [
										[
											["STATICWEAPON","Dot",[0.4,0.6],1]
										],
										[
											["MAN","Dot",[0.5,0.5],1]
										],
										[
											["CAR","Dot",[0.6,0.7],1],
											["TRUCK","Dot",[0.6,0.8],1]
										],
										[
											["TANK","Dot",[0.7,0.9],1],
											["APC","Dot",[0.6,0.9],1]
										],
										[
											["MOTORCYCLE","Dot",[0.2,0.6],0]
										],
										[
											["AIR","Dot",[0.5,1],0]
										],
										[
											["SHIP","Dot",[0.8,1.2],1]
										],
										[
											["OTHER","Dot",[0.6,0.6],1]
										]
									  ];
			};
//-----------------------------------------------------------------------------------------------
	case 3:	{		
				_setShowZones 		= 2;
				_setShowWPs 		= 0;
				_setShowUnit 		= [1,1,1,1];
				_setGroupType 		= 0;
				_setMarkerText		= [];
				_setMarkerDel 		= 1;
				_setMarkerRefresh 	= [0.2,0.2];
				_setSizeWpLine 		= [0.8,4];
				_setSizeLeaderLine 	= 0.5;
				_setSizeZoneLine 	= 0;
				_setSizeCampLine 	= 2.5;
				_setSizeZoneBorder 	= 3;
				_setArtiMarker 		= 1;
				_setCampMarker 		= 2;
				_setSideColor 		= [
										"ColorRed",
										"ColorBlue",
										"ColorYellow",
										"ColorGreen",
										"ColorWhite",
										"ColorBlack","ColorGreen"
									  ];
				_setMarkerClass		= [
										[
											["STATICWEAPON","Dot",[0.5,0.5],1]
										],
										[
											["MAN","Dot",[0.3,0.3],1]
										],
										[
											["CAR","Dot",[0.4,0.5],1],
											["TRUCK","Dot",[0.4,0.7],1]
										],
										[
											["TANK","Dot",[0.5,0.7],1],
											["APC","Dot",[0.5,0.7],1]
										],
										[
											["MOTORCYCLE","Dot",[0.2,0.6],1]
										],
										[
											["AIR","Dot",[0.6,0.8],1],
											["HELICOPTER","Dot",[0.6,0.8],1],
											["PLANE","Dot",[0.8,0.4],1],
											["ParachuteBase","Dot",[0.6,0.2],1]
										],
										[
											["SHIP","Dot",[0.8,1.2],1]
										],
										[
											["OTHER","Dot",[0.6,0.6],1]
										]
									  ];
			};
//-----------------------------------------------------------------------------------------------
	case 4:	{		
				_setShowZones 		= 2;
				_setShowWPs 		= 1;
				_setShowUnit 		= [1,1,1,1];
				_setGroupType 		= 0;
				_setMarkerText		= [];
				_setMarkerDel 		= 1;
				_setMarkerRefresh 	= [0.2,0.2];
				_setSizeWpLine 		= [0.8,8];
				_setSizeLeaderLine 	= 0.5;
				_setSizeZoneLine 	= 0;
				_setSizeCampLine 	= 0;
				_setSizeZoneBorder 	= 5;
				_setArtiMarker 		= 1;
				_setCampMarker 		= 2;
				_setSideColor 		= [
										"ColorRed",
										"ColorBlue",
										"ColorYellow",
										"ColorGreen",
										"ColorWhite",
										"ColorBlack","ColorGreen"
									  ];
				_setMarkerClass		= [
										[
											["STATICWEAPON","Dot",[0.5,0.5],1]
										],
										[
											["MAN","Dot",[0.3,0.3],1]
										],
										[
											["CAR","Dot",[0.4,0.5],1],
											["TRUCK","Dot",[0.4,0.7],1]
										],
										[
											["TANK","Dot",[0.5,0.7],1],
											["APC","Dot",[0.5,0.7],1]
										],
										[
											["MOTORCYCLE","Dot",[0.2,0.6],1]
										],
										[
											["AIR","Dot",[0.6,0.8],1],
											["HELICOPTER","Dot",[0.6,0.8],1],
											["PLANE","Dot",[0.8,0.4],1],
											["ParachuteBase","Dot",[0.6,0.2],1]
										],
										[
											["SHIP","Dot",[0.8,1.2],1]
										],
										[
											["OTHER","Dot",[0.6,0.6],1]
										]
									  ];
			};
//-----------------------------------------------------------------------------------------------
	case 5:	{		
				_setShowZones 		= 2;
				_setShowWPs 		= 2;
				_setShowUnit 		= [1,1,1,1];
				_setGroupType 		= 0;
				_setMarkerText		= [];
				_setMarkerDel 		= 1;
				_setMarkerRefresh 	= [0.1,0.1];
				_setSizeWpLine 		= [1,5];
				_setSizeLeaderLine 	= 0.5;
				_setSizeZoneLine 	= 3;
				_setSizeCampLine 	= 2;
				_setSizeZoneBorder 	= 6;
				_setArtiMarker 		= 1;
				_setCampMarker 		= 2;
				_setSideColor 		= [
										"ColorRed",
										"ColorBlue",
										"ColorYellow",
										"ColorGreen",
										"ColorWhite",
										"ColorBlack","ColorGreen"
									  ];
				_setMarkerClass		= [
										[
											["STATICWEAPON","Dot",[0.4,0.6],1]
										],
										[
											["MAN","Dot",[0.3,0.3],1]
										],
										[
											["CAR","Dot",[0.4,0.5],1],
											["TRUCK","Dot",[0.4,0.7],1]
										],
										[
											["TANK","Dot",[0.5,0.7],1],
											["APC","Dot",[0.5,0.7],1]
										],
										[
											["MOTORCYCLE","Dot",[0.2,0.6],1]
										],
										[
											["AIR","Dot",[0.6,0.8],1],
											["HELICOPTER","Dot",[0.6,0.8],1],
											["PLANE","Dot",[0.8,0.4],1],
											["ParachuteBase","Dot",[0.6,0.2],1]
										],
										[
											["SHIP","Dot",[0.8,1.2],1]
										],
										[
											["OTHER","Dot",[0.6,0.6],1]
										]
									  ];
			};
//-----------------------------------------------------------------------------------------------
	case 6:	{		
				_setShowZones 		= 2;
				_setShowWPs 		= 2;
				_setShowUnit 		= [1,1,1,1];
				_setGroupType 		= 0;
				_setMarkerText		= [];
				_setMarkerDel 		= 1;
				_setMarkerRefresh 	= [0.2,0.2];
				_setSizeWpLine 		= [1,5];
				_setSizeLeaderLine 	= 0.5;
				_setSizeZoneLine 	= 0;
				_setSizeCampLine 	= 2;
				_setSizeZoneBorder 	= 6;
				_setArtiMarker 		= 1;
				_setCampMarker 		= 2;
				_setSideColor 		= [
										"ColorRed",
										"ColorBlue",
										"ColorYellow",
										"ColorGreen",
										"ColorWhite",
										"ColorBlack","ColorYellow"
									  ];
				_setMarkerClass		= [
										[
											["STATICWEAPON","Dot",[0.4,0.4],0]
										],
										[
											["Man","ARMA_MARKER_Man",[0.5,0.5],1],
											["SquadLeaderE","ARMA_MARKER_Officer",[0.5,0.5],1],
											["SquadLeaderW","ARMA_MARKER_Officer",[0.5,0.5],1],
											["SquadLeaderG","ARMA_MARKER_Officer",[0.5,0.5],1],
											["OfficerE","ARMA_MARKER_Officer",[0.5,0.5],1],
											["OfficerW","ARMA_MARKER_Officer",[0.5,0.5],1],
											["OfficerG","ARMA_MARKER_Officer",[0.5,0.5],1],
											["SoldierESniper","ARMA_MARKER_SpecOp",[0.5,0.5],1],
											["SoldierWSniper","ARMA_MARKER_SpecOp",[0.5,0.5],1],
											["SoldierGSniper","ARMA_MARKER_SpecOp",[0.5,0.5],1],
											["SoldierEMedic","ARMA_MARKER_Medic",[0.5,0.5],1],
											["SoldierWMedic","ARMA_MARKER_Medic",[0.5,0.5],1],
											["SoldierGMedic","ARMA_MARKER_Medic",[0.5,0.5],1]
										],
										[
											["Car","ARMA_MARKER_UAZ",[0.5,0.5],1],
											["Truck","ARMA_MARKER_TruckMG",[0.5,0.5],1]
										],
										[
											["Tank","ARMA_MARKER_T72",[0.5,0.5],1],
											["APC","ARMA_MARKER_M113",[0.5,0.5],1]
										],
										[
											["Motorcycle","Dot",[0.5,0.5],1]
										],
										[
											["Air","Dot",[0.5,0.5],1],
											["Helicopter","ARMA_MARKER_Cobra",[0.5,0.5],1],
											["Plane","ARMA_MARKER_Harrier",[0.5,0.5],1],
											["ParachuteBase","Dot",[0.6,0.2],1]
										],
										[
											["Ship","ARMA_MARKER_Gunboat",[0.5,0.5],1]
										],
										[
											["Other","Dot",[0.6,0.6],1]
										]
									  ];
			};
//-----------------------------------------------------------------------------------------------
	Default {};
};

while{_s < count _MarkerSet} do
{
	_MarkerValues set[_s, (call compile (_MarkerSet select _s))];
	_s = _s + 1;
};
_MarkerValues